
Ext.Loader.setConfig({
    enabled: true,
    paths : {
        //Ext: '.',
        framework: 'framework',
        app: 'app',
        theme: 'theme',
        plugin: 'plugin'        
    }
});

Ext.require('framework.ASConstant');

Ext.application({
    name: 'appsemble',
    requires: ['framework.ASVari', 'Ext.Map', 'Ext.plugin.ListPaging', 'Ext.plugin.PullRefresh', 'Ext.util.JSONP', 
               'framework.store.BaseOfflineStore','framework.util.OnDemandLoad','framework.util.Device', 'framework.observer.Client',
       'framework.util.HtmlUtil','framework.util.Nav', 'framework.util.Net', 'framework.util.Util',
       'framework.util.SyncUtil', 'framework.store.AppInfoOfflineStore', 'framework.model.JsonData','framework.model.Version',
       'framework.model.Settings','framework.store.SettingsOfflineStore','framework.util.SettingsUtil',
       'Ext.data.proxy.Rest' ,
    ],
    views : [],
    controllers : [],
    viewport: {
        autoMaximize: true
    },
    init: function() {},
    launch: function() {
    	if (Device.isPhonegapApp()) {ASVari.PhoneGapReady = true;}    	
    	ASVari.sysLang = Util.getSysLang();
     	
    	Util.requireFile(null);
     	
    	Ext.Viewport.setMasked({ xtype: 'loadmask', message: ' ' });
        ASVari.app = this;
    	
    	ASVari.Platform = Device.getPlatform();
    	ASVari.UseLargerPng = framework.util.Util.isRetina();    	
    	ASVari.ScreenSize = framework.util.Util.getScreenSize();
    	console.log('start to Load Application...');
    	
    	Ext.apply(ASVari.RestParams, {pcode: ASVari.Platform, sw: ASVari.ScreenSize.w, sh: ASVari.ScreenSize.h });  
    	Ext.apply(Ext.MessageBox.OK,{text:Util.getMessageInner('messageOk',null,0)}); 
    	Ext.Date.monthNames = Util.getMessageInner('monthNamesSencha',[Ext.Date.monthNames],0);
    	//Ext.picker.Picker.doneButton='I\'m done!';
    	
    	if (ASVari.PhoneGapReady) {
	    	//OnDemandLoad.loadComponent('NativeLoader.js', function(){
	    		//console.log('Load NativeLoader.js success 111...');
	    		NativeLoader.initNativeApp(function () {
	    			console.log('Load NativeLoader.js success...');
	    		});
	    	//});
    	} else {
	    	//OnDemandLoad.loadComponent('WebLoader.js', function(){
	    		//console.log('Load WebLoader.js success...');
	    		WebLoader.initNativeApp(function () {
	    			console.log('Load WebLoader.js success...');
	    		});
	    	//});
    	}
    }
});


var appInfoRequestPass = function(json) {
	
	ASVari.appInfo = json.app;
	
	if (Device.isPhonegapApp()) {
		var ptype = ASVari.appInfo.payType; // from app-config.js
		if (ASVari.IsOnline){
			ptype = ASVari.PayType; // from checkNetwork method
		}
		
		var c1 = ptype < 1 && ( Ext.os.is('iOS') || Ext.os.is('BlackBerry') );
		//var c2 = ASVari.appInfo.payType < 2 && Ext.os.deviceType == 'Tablet';
		if (c1) {
			Ext.Viewport.setHtml(Util.getMessageInner('appUnavailable', [ASVari.appInfo.clientEmail], 0));
		    Device.CloseStartupScreen();
		    Device.CloseLoadingMask();
		    Ext.Viewport.setMasked(false);
			return;
		}
	}

	if (Device.isPhonegapApp()) {
		ASVari.PhoneGapReady = true;
	}

	var homeIcon = ASVari.appInfo.homeIcon;
	var startScreen = ASVari.appInfo.startScreen;
	if (ASVari.UseLargerPng) {
		homeIcon = Util.largerPngName(homeIcon);
		startScreen = Util.largerPngName(startScreen);
	}
	
	OnDemandLoad.removeRedundantHeadLink();	
	OnDemandLoad.addHeadLink('apple-touch-icon', homeIcon);
	OnDemandLoad.addHeadLink('apple-touch-startup-image', startScreen);
	OnDemandLoad.addInternalStyle(ASVari.appInfo.internalStyle);
	
	initAppRes(json); 
    createComponents(ASVari.app);  
    
    if (Device.isPhonegapApp() && Ext.os.is.Android) {
        document.addEventListener("backbutton", function () {
            framework.util.Nav.onAndroidBack();
        }, false);
    }
    
    Device.CloseStartupScreen();
    Device.CloseLoadingMask();
    
	//SyncUtil.syncData();
	if (Device.isPhonegapApp() && ASVari.IsOnline) {
		SyncUtil.syncAll();
	}
	
    ASVari.InitSuccess=true;    
   
};
var appRequestFail = function(json) {
	Device.CloseStartupScreen();
	Ext.Viewport.add({html: json.desc});
    Ext.Viewport.setMasked(false);
};
var appRequestError = function(json) {
	Device.CloseStartupScreen();
	//Ext.Viewport.add({html: 'Connection error, please check your network'});
	Ext.Viewport.add({html: Util.getMessageInner('net_conn_error',null,0)});
    Ext.Viewport.setMasked(false);
};

var initAppRes = function(json) {
	document.title = json.app.name;
	
	ASVari.appIcon = json.app.iconImg;
    
    var tcode = framework.util.Util.getUrlParam('tcode');
    ASVari.tcode = (tcode == '')? json.app.theme : tcode;
    
    OnDemandLoad.load('theme/platform/'+ASVari.Platform.toLowerCase()+'/platform.css');  
    OnDemandLoad.load('theme/theme/' + ASVari.tcode + '/theme.css');
    
    ASVari.mainControllerName = 'framework.controller.MainController';
    Ext.require(ASVari.mainControllerName);
    
    ASVari.mainViewName = 'theme.platform.'+ASVari.Platform.toLowerCase()+'.MainView'; 
    Ext.require(ASVari.mainViewName);
    
    var modules = json.app.subs;
    ASVari.pluginViewArr = new Array();
    for (var i = 0; i < modules.length; i++) {
        var subId =  modules[i].subId;
        var headline =  modules[i].headline;
        var code =  modules[i].code;
        var layout =  modules[i].layout;
        var iconImg =  modules[i].iconImg;
        var payType =  modules[i].payType;
        
        var iconText =  modules[i].iconText;
        if(ASVari.sysLang=='zh-cn'){
        	if(code == 'more'){
        		headline = Util.getMessageInner('headlineMore',null,0);
        		iconText = Util.getMessageInner('more',null,0);
        	}
        }
        
        var capCode = Util.capFirstLetter(code);
        Ext.require('plugin.' + code + '.model.' + capCode);
        
        var controllerName = 'plugin.'+code+'.'+capCode+'Controller';
        var viewName = 'plugin.'+code+'.layout.'+layout+'.view.'+capCode+'View';
		var storeName = 'plugin.'+code+'.store.'+capCode+'Store';

		ASVari.pluginViewArr.push({
            subId: subId,
            headline: headline,
            code: code,
            payType: payType,
            capCode: capCode,
            layout: layout,
            iconImg: iconImg,
            iconText: iconText,            
            viewName: viewName,
            controllerName: controllerName,
			storeName: storeName,
			//offlineStoreName: offlineStoreName,
            pluginKey: code + '_' + subId,
            pluginCss: 'plugin/'+code+'/res/plugin.css',
            layoutCss: 'plugin/'+code+'/layout/'+layout+'/res/layout.css'
        });         
    }
    
    ASVari.PLUGIN_KEY_MAP_BY_INDEX = Ext.create('Ext.util.HashMap');
	ASVari.PLUGIN_MAP_BY_KEY = Ext.create('Ext.util.HashMap');

    for (var i = 0; i < ASVari.pluginViewArr.length ; i++) {
        var pluginMap = Ext.create('Ext.util.HashMap');
        
        pluginMap.add('headline', ASVari.pluginViewArr[i].headline);
        pluginMap.add('code', ASVari.pluginViewArr[i].code);
        pluginMap.add('capCode', ASVari.pluginViewArr[i].capCode);
        pluginMap.add('payType', ASVari.pluginViewArr[i].payType);
        
        pluginMap.add('viewName', ASVari.pluginViewArr[i].viewName);
        pluginMap.add('controllerName', ASVari.pluginViewArr[i].controllerName);
		pluginMap.add('storeName', ASVari.pluginViewArr[i].storeName);	

        pluginMap.add('pluginCss', ASVari.pluginViewArr[i].pluginCss);
        pluginMap.add('layoutCss', ASVari.pluginViewArr[i].layoutCss);
        pluginMap.add('layoutName', ASVari.pluginViewArr[i].layout);
        
        ASVari.PLUGIN_KEY_MAP_BY_INDEX.add(i, ASVari.pluginViewArr[i].pluginKey);
        ASVari.PLUGIN_MAP_BY_KEY.add(ASVari.pluginViewArr[i].pluginKey, pluginMap);
    }
};

var createComponents = function(app) {
    createMainController(app);
    
    Ext.require(ASVari.mainViewName);
    Ext.create(ASVari.mainViewName);
    
    ASVari.CURRENT_PLUGIN_KEY = framework.util.Util.getUrlParam('plg');
    if(!ASVari.CURRENT_PLUGIN_KEY) {
    	ASVari.CURRENT_PLUGIN_KEY = ASVari.PLUGIN_KEY_MAP_BY_INDEX.get(0);
    }

    // Prevent launching externalLink plugins on app launch.
    var i=0, pluginKeyParts;
    while(true) {
        if(i > ASVari.pluginViewArr.length) {
            // Everything is an externalLink plugin! Give up and just load the first one.
            ASVari.CURRENT_PLUGIN_KEY = framework.util.Util.getUrlParam('plg');
            if(!ASVari.CURRENT_PLUGIN_KEY) {
                ASVari.CURRENT_PLUGIN_KEY = ASVari.PLUGIN_KEY_MAP_BY_INDEX.get(0);
            }
            break
        } else {
            pluginKeyParts = ASVari.CURRENT_PLUGIN_KEY.split('_')
            if(pluginKeyParts[0] == 'externalLink' || pluginKeyParts[0] == 'more' || pluginKeyParts[0] == 'offline') {
                // Try the next plugin...
                ASVari.CURRENT_PLUGIN_KEY = ASVari.PLUGIN_KEY_MAP_BY_INDEX.get(i);
                i++
            } else {
                // This plugin is OK - it is not externalLink
                break
            }
        }
    }

    initNavCmp();
    
    setTitleAsBackButton4Android();
    HtmlUtil.applyAppSembleStyle();

    Nav.showPluginByKey(ASVari.CURRENT_PLUGIN_KEY, app);
};

var createMainController = function(app) {
    controllerInst = Ext.create(ASVari.mainControllerName, {
        application: app
    });
    controllerInst.init(app);
    console.log('MainController : ' + ASVari.mainControllerName + '" created');
};

var initNavCmp = function() {
    if (ASVari.Platform == 'Android') {
        initMenuPage();
        Ext.getCmp('menuButton4Android').show();
        return;
    }
    addPluginButtonInNavbar();
    framework.util.HtmlUtil.highlightNavbutton();
};

var addPluginButtonInNavbar = function() {
	framework.util.Util.getTabNumByScreenWidth();
    var itemInTabbar = ASVari.pluginNumInTabbar;

    if (ASVari.pluginViewArr.length-2 <= itemInTabbar) {

        for (var i = 0; i < ASVari.pluginViewArr.length-2; i++) {
        	var icon = ASVari.pluginViewArr[i].iconImg;
        	if (ASVari.UseLargerPng) {
        		icon = Util.largerPngName(icon);
        	}
        	
            var pluginButton = {
                id: ASVari.pluginViewArr[i].code + '_' + ASVari.pluginViewArr[i].subId, 
                text: ASVari.pluginViewArr[i].iconText,
                icon: icon,
                iconAlign: 'top',
                labelCls: 'as_foot_a x-button-label'
            };
            
            Ext.getCmp('navbar').add([pluginButton]);
        }
    } else {
        for (var i = 0; i < itemInTabbar-1; i++) {
        	var icon = ASVari.pluginViewArr[i].iconImg;
        	if (ASVari.UseLargerPng) {
        		icon = Util.largerPngName(icon);
        	}
            var pluginButton = {
                id: ASVari.pluginViewArr[i].code + '_' + ASVari.pluginViewArr[i].subId, 
                text: ASVari.pluginViewArr[i].iconText,
                icon: icon,
                iconAlign: 'top',
                labelCls: 'as_foot_a x-button-label'
            };
            Ext.getCmp('navbar').add([pluginButton]);
        }
        
        // add more plugin
        var lst = ASVari.pluginViewArr.length - 2;
    	var icon2 = ASVari.pluginViewArr[lst].iconImg;
    	if (ASVari.UseLargerPng) {
    		icon2 = Util.largerPngName(icon2);
    	}
        var pluginButton = {
            id: ASVari.pluginViewArr[lst].code + '_' + ASVari.pluginViewArr[lst].subId, 
            text: ASVari.pluginViewArr[lst].iconText,
            icon: icon2,
            iconAlign: 'top',
            labelCls: 'as_foot_a x-button-label',
            style: 'background: none; border: none;'
        };
        Ext.getCmp('navbar').add([pluginButton]);
    }
};

var initMenuPage = function() {
    var menuPopup = Ext.getCmp('MenuPage');         
    if (!menuPopup) {
        Ext.require('framework.view.menu.MenuPage');
        menuPopup = Ext.create('framework.view.menu.MenuPage');                         
    }
    
    var menuPage = Ext.getCmp('MenuPage');
    var menuPageItems = new Array();
    for (var i = 0; i < ASVari.pluginViewArr.length-2; i++) {
        menuPageItems.push({
            pluginKey: ASVari.pluginViewArr[i].pluginKey,
            text : ASVari.pluginViewArr[i].iconText
        });
    }
//    menuPageItems.push({
//        pluginKey: 'func_sync',
//        text : 'Sync Data'
//    });
    var menuPageStore = new Ext.data.Store({
        fields : [ 'pluginKey', 'text'],
        data : menuPageItems
    }); 
    menuPage.setStore(menuPageStore);
};

var setTitleAsBackButton4Android = function() {
    var androidBackButton = Ext.DomQuery.select('.as_back_button_indication')[0];
    if (androidBackButton) {
        Ext.get(androidBackButton).on('tap', function(){
         	if (Ext.get(androidBackButton).hasCls('as_android_top_back')) {
            	Nav.onBack();
        	}
        });
    }
};

var gotoPlugin = function(pluginKey, title, label) {
	if (typeof(Nav) != "undefined")  {
		Nav.showPluginByKey(pluginKey, ASVari.app);
		HtmlUtil.setPluginTitle(pluginKey, title, label);
	}
};

//Colky added
var getInitStatus = function() {

	if (typeof(ASVari) != "undefined")  {
		return ASVari.InitSuccess;
	}
	
	return false;
};


